/*
 * Queue - A Queueing system that can be used to handle labs in higher education
 * Copyright (C) 2016-2024  Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package nl.tudelft.queue.dto.create.embeddables;

import lombok.*;
import lombok.experimental.SuperBuilder;
import nl.tudelft.librador.dto.create.Create;
import nl.tudelft.queue.dto.create.constraints.ClusterConstraintCreateDTO;
import nl.tudelft.queue.dto.create.constraints.ModuleDivisionConstraintCreateDTO;
import nl.tudelft.queue.model.embeddables.LabRequestConstraints;

@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class LabRequestConstraintsCreateDTO extends Create<LabRequestConstraints> {
	@Builder.Default
	private ClusterConstraintCreateDTO clusterConstraint = new ClusterConstraintCreateDTO();
	@Builder.Default
	private ModuleDivisionConstraintCreateDTO moduleDivisionConstraint = new ModuleDivisionConstraintCreateDTO();

	public LabRequestConstraintsCreateDTO(LabRequestConstraints constraints) {
		clusterConstraint = new ClusterConstraintCreateDTO();
		moduleDivisionConstraint = new ModuleDivisionConstraintCreateDTO();

		if (constraints.getClusterConstraint() != null) {
			clusterConstraint = new ClusterConstraintCreateDTO(
					constraints.getClusterConstraint().getClusters());
		}

		if (constraints.getModuleDivisionConstraint() != null) {
			moduleDivisionConstraint = new ModuleDivisionConstraintCreateDTO(
					constraints.getModuleDivisionConstraint().getDivisions());
		}
	}

	@Override
	protected void postApply(LabRequestConstraints data) {
		if (clusterConstraint.getClusters().isEmpty()) {
			data.setClusterConstraint(null);
		}

		if (moduleDivisionConstraint.getDivisions().isEmpty()) {
			data.setModuleDivisionConstraint(null);
		}
	}

	@Override
	public Class<LabRequestConstraints> clazz() {
		return LabRequestConstraints.class;
	}
}
